Subject: Re: [PATCH bpf-next] kbuild: add ability to generate BTF type info for vmlinux

From: Jiri Olsa <[email-masked]>
Date: Thu, 4 Apr 2019 10:47:20 +0200

On Wed, Apr 03, 2019 at 09:40:42PM -0300, Arnaldo Carvalho de Melo wrote:
> Em Wed, Apr 03, 2019 at 11:12:58AM +0200, Jiri Olsa escreveu:
> > On Wed, Apr 03, 2019 at 11:04:28AM +0200, Daniel Borkmann wrote:
> > > On 04/03/2019 10:46 AM, Jiri Olsa wrote:
> > > > On Tue, Apr 02, 2019 at 09:49:50AM -0700, [email-masked] wrote:
> > > >> From: Andrii Nakryiko <[email-masked]>
> > > >>
> > > >> This patch adds new config option to trigger generation of BTF type
> > > >> information from DWARF debuginfo for vmlinux and kernel modules through
> > > >> pahole, which in turn relies on libbpf for btf_dedup() algorithm.
> > > > I'm using the latest pahole from git tree:
> 
> > > >   https://github.com/acmel/dwarves.git
> 
> I've updated this oen as well, but the canonical one is at:
> 
> git://git.kernel.org/pub/scm/devel/pahole/pahole.git
> 
> See the fix below.
> 
> > > > and getting pahole crash:
> 
> > > >   LD      vmlinux
> > > >   BTF     vmlinux
> > > > die__process_inline_expansion: DW_TAG_label (0xa) @ <0x3eef8> not handled!
> > > > scripts/link-vmlinux.sh: line 96: 31222 Segmentation fault      (core dumped) LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
> > > > make[1]: *** [/home/jolsa/linux/Makefile:1025: vmlinux] Error 139
> > > > make: *** [Makefile:170: sub-make] Error 2
> 
> > > > is there some other source/dependency I'm missing?
> 
> > > Yesterday night, I've tested with [0] but seems to have the same HEAD as
> > > the github repo you pointed out. Seems the above is coming from pahole's
> > > __die__process_tag() bailing out with default for DW_TAG_label?
> 
> > > On my side worked fine:
>  
> > hum, I also had to change the version of pahole in the patch to allow
> > version v1.12, because both latest pahole sources are on version 1.12,
> > did u have to do that? looks like there's v1.13 somewhere ;-)
> 
> So, I've reproduced the problem and fixed it, please pull my latest
> master branch from git://git.kernel.org/pub/scm/devel/pahole/pahole.git,
> please do the hack to make it expect v1.12, I'll try and relase v1.13
> soon, if nothing else pops up soon.

  ...
  LD      vmlinux
  BTF     vmlinux
  SORTEX  vmlinux

works nicely now, thanks ;-)

jirka